<?php  ini_set('display_errors', 'On');   error_reporting(E_ALL);
$this_script	= basename(__FILE__);	
#
$SITE		= array();
#
if 	(is_file('wsLoadSettings.php') ) {
	echo 'STEP 1: Loading a settings file for release 2.7 or later<br />'.PHP_EOL;
	include 'wsLoadSettings.php';
}
elseif 	(is_file('wsSettings.php') ) {
	echo 'STEP 1: Loading a settings file for release 2.6 or earlier <br />'.PHP_EOL;
	include 'wsSettings.php';
	include_once 'wsSettingsWeather.php';
}
elseif 	(is_file('Settings.php') ) {
	echo 'STEP 1: Loading a settings file for Saratoga<br />'.PHP_EOL;
	include 'Settings.php';
	if 	(is_file('Settings-weather.php') ) {
		include_once 'Settings-weather.php';
	}
}
else  { echo '<h3>ERROR No settings file found, program stops.</h3>'; exit;
}
#
$settings	= array();
$start		= '';

print_arr($start, $SITE);

function print_arr($start, $arr) { 
	global $settings;
	if ($start <> '') {$start .= '_';} 	
	foreach($arr as $key => $value) {
		if (is_array($value) ) {
			print_arr($key,$value);
		}
		else {	$settings[] =  '|'.$start.$key.'|'.$value.'|';
		} 
	}
}
sort ($settings);
#echo '<pre>'.PHP_EOL; print_r($settings); exit;

$string	= '';
for ($n1=0; $n1 < count ($settings); $n1++) {
	$string .= $settings[$n1].PHP_EOL;
}
#echo '<pre>'.PHP_EOL;  echo $string;
echo 'STEP 2: Generating text file with old settings<br />'.PHP_EOL;
if (isset ($SITE['cacheDir']) ) {$file_out = $SITE['cacheDir'].'oldsettings.txt';} else {$file_out = './cache/oldsettings.txt';}
if (isset ($SITE['cacheDir']) ) {$zip1_out = $SITE['cacheDir'].'oldsettings.zip';} else {$zip1_out = './cache/oldsettings.zip';}
$return = file_put_contents ($file_out,$string);
if ($return == false) {
	echo '<pre><h3>ERROR file not written correctly, error returned when writing '.$file_out.'</h3>';
	echo $string;
	return;
}
$folders= str_replace($this_script,'',$_SERVER['REQUEST_URI']);
$link	= 'HTTP://'.$_SERVER['SERVER_NAME'].$folders.$file_out;
$files_to_zip = array($file_out);
//if true, good; if false, zip creation failed
$result = create_zip($files_to_zip,$zip1_out);
$link_zip='HTTP://'.$_SERVER['SERVER_NAME'].$folders.$zip1_out;

echo 'STEP 3: File is saved as <a href="'.$link.'" target="_blank"><b> '.$link.' </b></a><br />
STEP 4: Please check the file by clicking on the link and return here for the last step.<br />
STEP 5: Download a zip <a href="'.$link_zip.'" target="_blank"><b> '.$link_zip.' </b></a><br />'.PHP_EOL;




/* creates a compressed zip file */
function create_zip($files = array(),$destination = '',$overwrite = false) {
	//if the zip file already exists and overwrite is false, return false
	if(file_exists($destination) && !$overwrite) { return false; }
	//vars
	$valid_files = array();
	//if files were passed in...
	if(is_array($files)) {
		//cycle through each file
		foreach($files as $file) {
			//make sure the file exists
			if(file_exists($file)) {
				$valid_files[] = $file;
			}
		}
	}
	//if we have good files...
	if(count($valid_files)) {
		//create the archive
		$zip = new ZipArchive();
		if($zip->open($destination,$overwrite ? ZIPARCHIVE::OVERWRITE : ZIPARCHIVE::CREATE) !== true) {
			return false;
		}
		//add the files
		foreach($valid_files as $file) {
			$zip->addFile($file,$file);
		}
		//debug
		//echo 'The zip archive contains ',$zip->numFiles,' files with a status of ',$zip->status;
		
		//close the zip -- done!
		$zip->close();
		
		//check to make sure the file exists
		return file_exists($destination);
	}
	else
	{
		return false;
	}
}